check: Allow partial test names
[xfstests-dev.git] / check
1 #!/bin/bash
2 #
3 # Control script for QA
4 #
5 # Copyright (c) 2000-2002,2006 Silicon Graphics, Inc.  All Rights Reserved.
6 #
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License as
9 # published by the Free Software Foundation.
10 #
11 # This program is distributed in the hope that it would be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
14 # GNU General Public License for more details.
15 #
16 # You should have received a copy of the GNU General Public License
17 # along with this program; if not, write the Free Software Foundation,
18 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
19 #
20 #
21
22 tmp=/tmp/$$
23 status=0
24 needwrap=true
25 needsum=true
26 n_try=0
27 try=""
28 n_bad=0
29 sum_bad=0
30 bad=""
31 notrun=""
32 interrupt=true
33 diff="diff -u"
34 showme=false
35 have_test_arg=false
36 randomize=false
37 export here=`pwd`
38 xfile=""
39
40 # start the initialisation work now
41 iam=check
42
43 export MSGVERB="text:action"
44 export QA_CHECK_FS=${QA_CHECK_FS:=true}
45
46 # number of diff lines from a failed test, 0 for whole output
47 export DIFF_LENGTH=${DIFF_LENGTH:=10}
48
49 # by default don't output timestamps
50 timestamp=${TIMESTAMP:=false}
51
52 rm -f $tmp.list $tmp.tmp $tmp.grep $here/$iam.out $tmp.xlist
53
54 # we need common/config
55 if ! . ./common/config
56 then
57     echo "$iam: failed to source common/config"
58     exit 1
59 fi
60
61 SRC_GROUPS="generic shared"
62 export SRC_DIR="tests"
63
64 usage()
65 {
66     echo "Usage: $0 [options] [testlist]"'
67
68 check options
69     -nfs                test NFS
70     -cifs               test CIFS
71     -tmpfs              test TMPFS
72     -l                  line mode diff
73     -udiff              show unified diff (default)
74     -n                  show me, do not run tests
75     -T                  output timestamps
76     -r                  randomize test order
77     --large-fs          optimise scratch device for large filesystems
78     -s section          run only specified section from config file
79
80 testlist options
81     -g group[,group...] include tests from these groups
82     -x group[,group...] exclude tests from these groups
83     -X file             exclude individual tests
84     -E external_file    exclude individual tests
85     [testlist]          include tests matching names in testlist
86 '
87             exit 0
88 }
89
90 get_group_list()
91 {
92         grp=$1
93
94         for d in $SRC_GROUPS $FSTYP; do
95                 l=$(sed -n < $SRC_DIR/$d/group \
96                         -e 's/#.*//' \
97                         -e 's/$/ /' \
98                         -e "s;^\($VALID_TEST_NAME\).* $grp .*;$SRC_DIR/$d/\1;p")
99                 grpl="$grpl $l"
100         done
101         echo $grpl
102 }
103
104 # Find all tests, excluding files that are test metadata such as group files.
105 # It matches test names against $VALID_TEST_NAME defined in common/rc
106 get_all_tests()
107 {
108         touch $tmp.list
109         for d in $SRC_GROUPS $FSTYP; do
110                 ls $SRC_DIR/$d/* | \
111                         grep -v "\..*" | \
112                         grep "^$SRC_DIR/$d/$VALID_TEST_NAME"| \
113                         grep -v "group\|Makefile" >> $tmp.list 2>/dev/null
114         done
115 }
116
117 # takes the list of tests to run in $tmp.list, and removes the tests passed to
118 # the function from that list.
119 trim_test_list()
120 {
121         test_list="$*"
122
123         rm -f $tmp.grep
124         numsed=0
125         for t in $test_list
126         do
127             if [ $numsed -gt 100 ]; then
128                 grep -v -f $tmp.grep <$tmp.list >$tmp.tmp
129                 mv $tmp.tmp $tmp.list
130                 numsed=0
131                 rm -f $tmp.grep
132             fi
133             echo "^$t\$" >>$tmp.grep
134             numsed=`expr $numsed + 1`
135         done
136         grep -v -f $tmp.grep <$tmp.list >$tmp.tmp
137         mv $tmp.tmp $tmp.list
138 }
139
140
141 _wallclock()
142 {
143     date "+%s"
144 }
145
146 _timestamp()
147 {
148     now=`date "+%T"`
149     echo -n " [$now]"
150 }
151
152 _prepare_test_list()
153 {
154         unset list
155         # Tests specified on the command line
156         if [ -s $tmp.arglist ]; then
157                 cat $tmp.arglist > $tmp.list
158         else
159                 touch $tmp.list
160         fi
161
162         # Specified groups to include
163         for group in $GROUP_LIST; do
164                 list=$(get_group_list $group)
165                 if [ -z "$list" ]; then
166                         echo "Group \"$group\" is empty or not defined?"
167                         exit 1
168                 fi
169
170                 for t in $list; do
171                         grep -s "^$t\$" $tmp.list >/dev/null || \
172                                                         echo "$t" >>$tmp.list
173                 done
174         done
175
176         if ! $have_test_arg && [ -z "$GROUP_LIST" ]; then
177                 # no test numbers, do everything
178                 get_all_tests
179         fi
180
181         # Specified groups to exclude
182         for xgroup in $XGROUP_LIST; do
183                 list=$(get_group_list $xgroup)
184                 if [ -z "$list" ]; then
185                         echo "Group \"$xgroup\" is empty or not defined?"
186                         exit 1
187                 fi
188
189                 trim_test_list $list
190         done
191
192         # sort the list of tests into numeric order
193         list=`sort -n $tmp.list | uniq`
194         rm -f $tmp.list $tmp.tmp $tmp.grep
195
196         if $randomize
197         then
198                 list=`echo $list | awk -f randomize.awk`
199         fi
200 }
201
202 # Process command arguments first.
203 while [ $# -gt 0 ]; do
204         case "$1" in
205         -\? | -h | --help) usage ;;
206
207         -nfs)   FSTYP=nfs ;;
208         -cifs)  FSTYP=cifs ;;
209         -tmpfs) FSTYP=tmpfs ;;
210
211         -g)     group=$2 ; shift ;
212                 GROUP_LIST="$GROUP_LIST ${group//,/ }"
213                 ;;
214
215         -x)     xgroup=$2 ; shift ;
216                 XGROUP_LIST="$XGROUP_LIST ${xgroup//,/ }"
217                 ;;
218
219         -X)     xfile=$2; shift ;
220                 for d in $SRC_GROUPS $FSTYP; do
221                         [ -f $SRC_DIR/$d/$xfile ] || continue
222                         for f in `cat $SRC_DIR/$d/$xfile`; do
223                                 echo $d/$f >> $tmp.xlist
224                         done
225                 done
226                 ;;
227         -E)     xfile=$2; shift ;
228                 if [ -f $xfile ]; then
229                         cat "$xfile" >> $tmp.xlist
230                 fi
231                 ;;
232         -s)     RUN_SECTION="$RUN_SECTION $2"; shift ;;
233         -l)     diff="diff" ;;
234         -udiff) diff="$diff -u" ;;
235
236         -n)     showme=true ;;
237         -r)     randomize=true ;;
238
239         -T)     timestamp=true ;;
240
241         --large-fs) export LARGE_SCRATCH_DEV=yes ;;
242         --extra-space=*) export SCRATCH_DEV_EMPTY_SPACE=${r#*=} ;;
243
244         -*)     usage ;;
245         *)      # not an argument, we've got tests now.
246                 have_test_arg=true ;;
247         esac
248
249         # if we've found a test specification, the break out of the processing
250         # loop before we shift the arguments so that this is the first argument
251         # that we process in the test arg loop below.
252         if $have_test_arg; then
253                 break;
254         fi
255
256         shift
257 done
258
259 # Process tests from command line now.
260 if $have_test_arg; then
261         while [ $# -gt 0 ]; do
262                 case "$1" in
263                 -*)     echo "Argments before tests, please!"
264                         status=1
265                         exit $status
266                         ;;
267                 *)      test_dir=`dirname $1`
268                         test_dir=${test_dir#$SRC_DIR/*}
269                         test_name=`basename $1`
270                         group_file=$SRC_DIR/$test_dir/group
271
272                         if egrep "^$test_name" $group_file >/dev/null ; then
273                                 # in group file ... OK
274                                 echo $SRC_DIR/$test_dir/$test_name >>$tmp.arglist
275                         else
276                                 # oops
277                                 echo "$1 - unknown test, ignored"
278                         fi
279                         ;;
280                 esac
281
282                 shift
283         done
284 fi
285
286 # we need common/rc
287 if ! . ./common/rc
288 then
289     echo "check: failed to source common/rc"
290     exit 1
291 fi
292
293 if [ `id -u` -ne 0 ]
294 then
295     echo "check: QA must be run as root"
296     exit 1
297 fi
298
299 _wipe_counters()
300 {
301         n_try="0"
302         n_bad="0"
303         unset try notrun bad
304 }
305
306 _wrapup()
307 {
308     seq="check"
309     check="$RESULT_BASE/check"
310
311     if $showme
312     then
313         :
314     elif $needwrap
315     then
316         if [ -f $check.time -a -f $tmp.time ]
317         then
318             cat $check.time $tmp.time \
319             | $AWK_PROG '
320         { t[$1] = $2 }
321 END     { if (NR > 0) {
322             for (i in t) print i " " t[i]
323           }
324         }' \
325             | sort -n >$tmp.out
326             mv $tmp.out $check.time
327         fi
328
329         echo "" >>$check.log
330         date >>$check.log
331         echo $list | fmt | sed -e 's/^/    /' -e "s;$SRC_DIR/;;g" >>$check.log
332         $interrupt && echo "Interrupted!" >>$check.log
333
334         echo "SECTION       -- $section" >>$tmp.summary
335         echo "=========================" >>$tmp.summary
336         if [ ! -z "$n_try" -a $n_try != 0 ]
337         then
338             echo "Ran:$try"
339             echo "Ran:$try" >>$tmp.summary
340         fi
341
342         if [ ! -z "$notrun" ]
343         then
344             echo "Not run:$notrun"
345             echo "Not run:$notrun" >>$check.log
346             echo "Not run:$notrun" >>$tmp.summary
347         fi
348
349         if [ ! -z "$n_bad" -a $n_bad != 0 ]
350         then
351             echo "Failures:$bad"
352             echo "Failed $n_bad of $n_try tests"
353             echo "Failures:$bad" | fmt >>$check.log
354             echo "Failed $n_bad of $n_try tests" >>$check.log
355             echo "Failures:$bad" >>$tmp.summary
356             echo "Failed $n_bad of $n_try tests" >>$tmp.summary
357         else
358             echo "Passed all $n_try tests"
359             echo "Passed all $n_try tests" >>$check.log
360             echo "Passed all $n_try tests" >>$tmp.summary
361         fi
362         echo "" >>$tmp.summary
363         needwrap=false
364     fi
365
366     sum_bad=`expr $sum_bad + $n_bad`
367     _wipe_counters
368     rm -f /tmp/*.rawout /tmp/*.out /tmp/*.err /tmp/*.time
369     if ! $OPTIONS_HAVE_SECTIONS; then
370         rm -f $tmp.*
371     fi
372 }
373
374 _summary()
375 {
376         _wrapup
377         if $showme; then
378                 :
379         elif $needsum; then
380                 count=`wc -L $tmp.summary | cut -f1 -d" "`
381                 cat $tmp.summary
382                 needsum=false
383         fi
384         rm -f $tmp.*
385 }
386
387 _check_filesystems()
388 {
389         if [ -f ${RESULT_DIR}/require_test ]; then
390                 _check_test_fs || err=true
391                 rm -f ${RESULT_DIR}/require_test
392         fi
393         if [ -f ${RESULT_DIR}/require_scratch ]; then
394                 _check_scratch_fs || err=true
395                 rm -f ${RESULT_DIR}/require_scratch
396         fi
397 }
398
399 _prepare_test_list
400
401 if $OPTIONS_HAVE_SECTIONS; then
402         trap "_summary; exit \$status" 0 1 2 3 15
403 else
404         trap "_wrapup; exit \$status" 0 1 2 3 15
405 fi
406
407 for section in $HOST_OPTIONS_SECTIONS; do
408         OLD_FSTYP=$FSTYP
409         OLD_MOUNT_OPTIONS=$MOUNT_OPTIONS
410         get_next_config $section
411
412         # Do we need to run only some sections ?
413         if [ ! -z "$RUN_SECTION" ]; then
414                 skip=true
415                 for s in $RUN_SECTION; do
416                         if [ $section == $s ]; then
417                                 skip=false
418                         fi
419                 done
420                 if $skip; then
421                         continue
422                 fi
423         fi
424
425         mkdir -p $RESULT_BASE
426         if [ ! -d $RESULT_BASE ]; then
427                 echo "failed to create results directory $RESULT_BASE"
428                 status=1
429                 exit
430         fi
431
432         if $OPTIONS_HAVE_SECTIONS; then
433                 echo "SECTION       -- $section"
434         fi
435
436         if $RECREATE_TEST_DEV || [ "$OLD_FSTYP" != "$FSTYP" ]; then
437                 echo "RECREATING    -- $FSTYP on $TEST_DEV"
438                 umount $TEST_DEV 2> /dev/null
439                 if ! _test_mkfs >$tmp.err 2>&1
440                 then
441                         echo "our local _test_mkfs routine ..."
442                         cat $tmp.err
443                         echo "check: failed to mkfs \$TEST_DEV using specified options"
444                         status=1
445                         exit
446                 fi
447                 out=`_mount_or_remount_rw "$MOUNT_OPTIONS" $TEST_DEV $TEST_DIR`
448                 if [ $? -ne 1 ]; then
449                         echo $out
450                         status=1
451                         exit
452                 fi
453                 _prepare_test_list
454         elif [ "$OLD_MOUNT_OPTIONS" != "$MOUNT_OPTIONS" ]; then
455                 umount $TEST_DEV 2> /dev/null
456                 out=`_mount_or_remount_rw "$MOUNT_OPTIONS" $TEST_DEV $TEST_DIR`
457                 if [ $? -ne 1 ]; then
458                         echo $out
459                         status=1
460                         exit
461                 fi
462         fi
463
464         init_rc
465
466         seq="check"
467         check="$RESULT_BASE/check"
468
469         # don't leave old full output behind on a clean run
470         rm -f $check.full
471
472         [ -f $check.time ] || touch $check.time
473
474         # print out our test configuration
475         echo "FSTYP         -- `_full_fstyp_details`"
476         echo "PLATFORM      -- `_full_platform_details`"
477         if [ ! -z "$SCRATCH_DEV" ]; then
478           echo "MKFS_OPTIONS  -- `_scratch_mkfs_options`"
479           echo "MOUNT_OPTIONS -- `_scratch_mount_options`"
480         fi
481         echo
482         needwrap=true
483
484         if [ ! -z "$SCRATCH_DEV" ]; then
485           umount $SCRATCH_DEV 2>/dev/null
486           # call the overridden mkfs - make sure the FS is built
487           # the same as we'll create it later.
488
489           if ! _scratch_mkfs >$tmp.err 2>&1
490           then
491               echo "our local _scratch_mkfs routine ..."
492               cat $tmp.err
493               echo "check: failed to mkfs \$SCRATCH_DEV using specified options"
494               status=1
495               exit
496           fi
497
498           # call the overridden mount - make sure the FS mounts with
499           # the same options that we'll mount with later.
500           if ! _scratch_mount >$tmp.err 2>&1
501           then
502               echo "our local mount routine ..."
503               cat $tmp.err
504               echo "check: failed to mount \$SCRATCH_DEV using specified options"
505               status=1
506               exit
507           fi
508         fi
509
510         seqres="$check"
511         _check_test_fs
512
513         for seq in $list
514         do
515             err=false
516
517             # the filename for the test and the name output are different.
518             # we don't include the tests/ directory in the name output.
519             export seqnum=`echo $seq | sed -e "s;$SRC_DIR/;;"`
520
521             # Similarly, the result directory needs to replace the tests/
522             # part of the test location.
523             group=`dirname $seq`
524             if $OPTIONS_HAVE_SECTIONS; then
525                 export RESULT_DIR=`echo $group | sed -e "s;$SRC_DIR;${RESULT_BASE}/$section;"`
526                 seqres="$RESULT_BASE/$section/$seqnum"
527             else
528                 export RESULT_DIR=`echo $group | sed -e "s;$SRC_DIR;$RESULT_BASE;"`
529                 seqres="$RESULT_BASE/$seqnum"
530             fi
531
532             mkdir -p $RESULT_DIR
533
534             echo -n "$seqnum"
535
536                 if $showme; then
537                         echo
538                         continue
539                 elif [ ! -f $seq ]; then
540                         # Try to get full name in case the user supplied only seq id
541                         # and the test has a name. A bit of hassle to find really
542                         # the test and not its sample output or helping files.
543                         bname=$(basename $seq)
544                         full_seq=$(find $(dirname $seq) -name $bname* -executable |
545                                 awk '(NR == 1 || length < length(shortest)) { shortest = $0 }\
546                                         END { print shortest }')
547                         if [ -f $full_seq ] \
548                                 && [ x$(echo $bname | grep -o "^$VALID_TEST_ID") != x ]; then
549                                 seq=$full_seq
550                                 seqnum=${full_seq#*/}
551                         fi
552                 fi
553
554                 if [ ! -f $seq ]; then
555                         echo " - no such test?"
556                 else
557                 # really going to try and run this one
558                 #
559                 rm -f $seqres.out.bad
560
561                 # check if we really should run it
562                 if [ -s $tmp.xlist ]; then
563                         if grep $seqnum $tmp.xlist > /dev/null 2>&1 ; then
564                                 echo "       [expunged]"
565                                 continue
566                         fi
567                 fi
568
569                 # slashes now in names, sed barfs on them so use grep
570                 lasttime=`grep -w ^$seqnum $check.time | awk '// {print $2}'`
571                 if [ "X$lasttime" != X ]; then
572                         echo -n " ${lasttime}s ..."
573                 else
574                         echo -n "       "       # prettier output with timestamps.
575                 fi
576                 rm -f core $seqres.notrun
577
578                 start=`_wallclock`
579                 $timestamp && echo -n " ["`date "+%T"`"]"
580                 [ ! -x $seq ] && chmod u+x $seq # ensure we can run it
581                 $LOGGER_PROG "run xfstest $seqnum"
582                 if [ -w /dev/kmsg ]; then
583                         export date_time=`date +"%F %T"`
584                         echo "run fstests $seqnum at $date_time" > /dev/kmsg
585                         # _check_dmesg depends on this log in dmesg
586                         touch ${RESULT_DIR}/check_dmesg
587                 fi
588                 ./$seq >$tmp.rawout 2>&1
589                 sts=$?
590                 $timestamp && _timestamp
591                 stop=`_wallclock`
592
593                 _fix_malloc <$tmp.rawout >$tmp.out
594                 rm -f $tmp.rawout
595
596                 if [ -f core ]
597                 then
598                     echo -n " [dumped core]"
599                     mv core $RESULT_BASE/$seqnum.core
600                     err=true
601                 fi
602
603                 if [ -f $seqres.notrun ]
604                 then
605                     $timestamp || echo -n " [not run] "
606                     $timestamp && echo " [not run]" && echo -n "        $seqnum -- "
607                     cat $seqres.notrun
608                     notrun="$notrun $seqnum"
609                 else
610                     if [ $sts -ne 0 ]
611                     then
612                         echo -n " [failed, exit status $sts]"
613                         err=true
614                     fi
615                     if [ ! -f $seq.out ]
616                     then
617                         echo " - no qualified output"
618                         err=true
619                     else
620
621                         # coreutils 8.16+ changed quote formats in error messages from
622                         # `foo' to 'foo'. Filter old versions to match the new version.
623                         sed -i "s/\`/\'/g" $tmp.out
624                         if diff $seq.out $tmp.out >/dev/null 2>&1
625                         then
626                             if $err
627                             then
628                                 :
629                             else
630                                 echo "$seqnum `expr $stop - $start`" >>$tmp.time
631                                 echo -n " `expr $stop - $start`s"
632                             fi
633                             echo ""
634                         else
635                             echo " - output mismatch (see $seqres.out.bad)"
636                             mv $tmp.out $seqres.out.bad
637                             $diff $seq.out $seqres.out.bad | {
638                                 if test "$DIFF_LENGTH" -le 0; then
639                                         cat
640                                 else
641                                         head -n "$DIFF_LENGTH"
642                                         echo "..."
643                                         echo "(Run '$diff $seq.out $seqres.out.bad'" \
644                                                 " to see the entire diff)"
645                                 fi; } | \
646                                 sed -e 's/^\(.\)/    \1/'
647                             err=true
648                         fi
649                     fi
650                     try="$try $seqnum"
651                     n_try=`expr $n_try + 1`
652                     _check_filesystems
653                     _check_dmesg || err=true
654                 fi
655
656             fi
657
658             # come here for each test, except when $showme is true
659             #
660             if $err
661             then
662                 bad="$bad $seqnum"
663                 n_bad=`expr $n_bad + 1`
664                 quick=false
665             fi
666
667             seq="after_$seqnum"
668         done
669         _wrapup
670         echo
671
672         umount $TEST_DEV 2> /dev/null
673         umount $SCRATCH_DEV 2> /dev/null
674 done
675
676 interrupt=false
677 status=`expr $sum_bad`
678 exit